Commit 84963b5b authored by Marc-André Lureau's avatar Marc-André Lureau Committed by Alex Bennée
Browse files

archive-source: also create a stash for submodules



"git archive" fails when a submodule has a modification, because "git
stash create" doesn't handle submodules. Let's teach our
archive-source.sh to handle modifications in submodules the same way
as qemu tree, by creating a stash.

Signed-off-by: default avatarMarc-André Lureau <marcandre.lureau@redhat.com>
Message-Id: <20190708200250.12017-1-marcandre.lureau@redhat.com>
Tested-by: default avatarPhilippe Mathieu-Daudé <philmd@redhat.com>
Signed-off-by: default avatarAlex Bennée <alex.bennee@linaro.org>
parent 4da6c0f9
Loading
Loading
Loading
Loading
+10 −8
Original line number Diff line number Diff line
@@ -39,14 +39,16 @@ function cleanup() {
}
trap "cleanup" 0 1 2 3 15

if git diff-index --quiet HEAD -- &>/dev/null
function tree_ish() {
    local retval='HEAD'
    if ! git diff-index --quiet --ignore-submodules=all HEAD -- &>/dev/null
    then
    HEAD=HEAD
else
    HEAD=$(git stash create)
        retval=$(git stash create)
    fi
    echo "$retval"
}

git archive --format tar $HEAD > "$tar_file"
git archive --format tar "$(tree_ish)" > "$tar_file"
test $? -ne 0 && error "failed to archive qemu"
for sm in $submodules; do
    status="$(git submodule status "$sm")"
@@ -62,7 +64,7 @@ for sm in $submodules; do
            echo "WARNING: submodule $sm is out of sync"
            ;;
    esac
    (cd $sm; git archive --format tar --prefix "$sm/" $smhash) > "$sub_file"
    (cd $sm; git archive --format tar --prefix "$sm/" $(tree_ish)) > "$sub_file"
    test $? -ne 0 && error "failed to archive submodule $sm ($smhash)"
    tar --concatenate --file "$tar_file" "$sub_file"
    test $? -ne 0 && error "failed append submodule $sm to $tar_file"